- NAME
- DESCRIPTION
- SYNOPSIS
- FUNCTIONS

- linfit1d

# NAME

PDL::Fit::Linfit - routines for fitting data with linear combinations of functions.

# DESCRIPTION

This module contains routines to perform general curve-fits to a set (linear combination) of specified functions.

Given a set of Data:

      (y0, y1, y2, y3, y4, y5, ...ynoPoints-1)

The fit routine tries to model y as:

      y' = beta0*x0 + beta1*x1 + ... beta_noCoefs*x_noCoefs

Where x0, x1, ... x_noCoefs, is a set of functions (curves) that the are combined linearly using the beta coefs to yield an approximation of the input data.

The Sum-Sq error is reduced to a minimum in this curve fit.

Inputs:

$data
  This is your data you are trying to fit. Size=n

$functions
  2D array. size (n, noCoefs). Row 0 is the evaluation of function x0 at all the points in y. Row 1 is the evaluation of of function x1 at all the points in y, ... etc.

  Example of $functions array Structure:

  $data is a set of 10 points that we are trying to model using the linear combination of 3 functions.

       $functions = ( [ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ],  # Constant Term
                      [ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 ],  # Linear Slope Term
                      [ 0, 2, 4, 9, 16, 25, 36, 49, 64, 81] # quadradic term
                  )

# SYNOPSIS

        $yfit = linfit1d $data, $funcs

# FUNCTIONS

## linfit1d

1D Fit linear combination of supplied functions to data using min chi^2 (least squares).

     Usage: ($yfit, [$coeffs]) = linfit1d [$xdata], $data, $fitFuncs, [Options...]

Signature: (xdata(n); ydata(n); $fitFuncs(n,order); [o]yfit(n); [o]coeffs(order))

Uses a standard matrix inversion method to do a least squares/min chi^2 fit to data.

Returns the fitted data and optionally the coefficients.

One can thread over extra dimensions to do multiple fits (except the order can not be threaded over - i.e. it must be one fixed set of fit functions `fitFuncs`.

The data is normalised internally to avoid overflows (using the mean of the abs value) which are common in large polynomial series but the returned fit, coeffs are in unnormalised units.

      # Generate data from a set of functions
      $xvalues = sequence(100);
      $data = 3*$xvalues + 2*cos($xvalues) + 3*sin($xvalues*2);

      # Make the fit Functions
      $fitFuncs = cat $xvalues, cos($xvalues), sin($xvalues*2);

      # Now fit the data, Coefs should be the coefs in the linear combination
      #   above: 3,2,3
      ($yfit, $coeffs) = linfit1d $data,$fitFuncs;

      Options:
         Weights    Weights to use in fit, e.g. 1/$sigma**2 (default=1)